from pytest_common import pytest, run


@pytest.mark.parametrize(
    "field, M, N",
    [
        (["0"], 1, 1),
        (["01"], 2, 1),
        (["0", "1"], 1, 2),
        (["01", "32"], 2, 2),
        (["012", "543"], 3, 2),
        (["01", "52", "43"], 2, 3),
        (["012", "783", "654"], 3, 3),
        (["012345", "567896", "432107", "321098"], 6, 4),
        (["012345", "789016", "678927", "565438", "432109"], 6, 5),
        (["0123456", "9012347", "8123458", "7098769", "6543210"], 7, 5),
        ([
             "01234567890123456789012345678901234567890123456789"
             "01234567890123456789012345678901234567890123456789",
             "56789012345678901234567890123456789012345678901234"
             "56789012345678901234567890123456789012345678901230",
             "43456789012345678901234567890123456789012345678901"
             "23456789012345678901234567890123456789012345678941",
             "32345678901234567890123456789012345678901234567890"
             "12345678901234567890123456789012345678901234567052",
             "21256789012345678901234567890123456789012345678901"
             "23456789012345678901234567890123456789012345678163",
             "10149012345678901234567890123456789012345678901234"
             "56789012345678901234567890123456789012345678989274",
             "09038567890123456789012345678901234567890123456789"
             "01234567890123456789012345678901234567890123090385",
             "98927434567890123456789012345678901234567890123456"
             "78901234567890123456789012345678901234567894101496",
             "87816323456789012345678901234567890123456789012345"
             "67890123456789012345678901234567890123456705212507",
             "76705212567890123456789012345678901234567890123456"
             "78901234567890123456789012345678901234567816323618",
             "65694101490123456789012345678901234567890123456789"
             "01234567890123456789012345678901234567898927434729",
             "54583090385678901234567890123456789012345678901234"
             "56789012345678901234567890123456789012309038545830",
             "43472989274345678901234567890123456789012345678901"
             "23456789012345678901234567890123456789410149656941",
             "32361878163234567890123456789012345678901234567890"
             "12345678901234567890123456789012345670521250767052",
             "21250767052125678901234567890123456789012345678901"
             "23456789012345678901234567890123456781632361878163",
             "10149656941014901234567890123456789012345678901234"
             "56789012345678901234567890123456789892743472989274",
             "09038545830903856789012345678901234567890123456789"
             "01234567890123456789012345678901230903854583090385",
             "98927434729892743456789012345678901234567890123456"
             "78901234567890123456789012345678941014965694101496",
             "87816323618781632345678901234567890123456789012345"
             "67890123456789012345678901234567052125076705212507",
             "76705212507670521256789012345678901234567890123456"
             "78901234567890123456789012345678163236187816323618",
             "65694101496569410149012345678901234567890123456789"
             "01234567890123456789012345678989274347298927434729",
             "54583090385458309038567890123456789012345678901234"
             "56789012345678901234567890123090385458309038545830",
             "43472989274347298927434567890123456789012345678901"
             "23456789012345678901234567894101496569410149656941",
             "32361878163236187816323456789012345678901234567890"
             "12345678901234567890123456705212507670521250767052",
             "21250767052125076705212567890123456789012345678901"
             "23456789012345678901234567816323618781632361878163",
             "10149656941014965694101490123456789012345678901234"
             "56789012345678901234567898927434729892743472989274",
             "09038545830903854583090385678901234567890123456789"
             "01234567890123456789012309038545830903854583090385",
             "98927434729892743472989274345678901234567890123456"
             "78901234567890123456789410149656941014965694101496",
             "87816323618781632361878163234567890123456789012345"
             "67890123456789012345670521250767052125076705212507",
             "76705212507670521250767052125678901234567890123456"
             "78901234567890123456781632361878163236187816323618",
             "65694101496569410149656941014901234567890123456789"
             "01234567890123456789892743472989274347298927434729",
             "54583090385458309038545830903856789012345678901234"
             "56789012345678901230903854583090385458309038545830",
             "43472989274347298927434729892743456789012345678901"
             "23456789012345678941014965694101496569410149656941",
             "32361878163236187816323618781632345678901234567890"
             "12345678901234567052125076705212507670521250767052",
             "21250767052125076705212507670521256789012345678901"
             "23456789012345678163236187816323618781632361878163",
             "10149656941014965694101496569410149012345678901234"
             "56789012345678989274347298927434729892743472989274",
             "09038545830903854583090385458309038567890123456789"
             "01234567890123090385458309038545830903854583090385",
             "98927434729892743472989274347298927434567890123456"
             "78901234567894101496569410149656941014965694101496",
             "87816323618781632361878163236187816323456789012345"
             "67890123456705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212567890123456"
             "78901234567816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101490123456789"
             "01234567898927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385678901234"
             "56789012309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274345678901"
             "23456789410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163234567890"
             "12345670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125678901"
             "23456781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014901234"
             "56789892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903856789"
             "01230903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743456"
             "78941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632345"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521256"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309038"
             "90385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298927"
             "01496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187816"
             "12507670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076705"
             "23618781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014965694"
             "34729892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903854583"
             "45830903854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729892743472"
             "56941014965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618781632361"
             "67052125076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507670521250"
             "78163236187816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101496569410149"
             "89274347298927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090385458309032"
             "10385458309038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989274347298987"
             "65496569410149656941014965694101496569410149656941",
             "32361878163236187816323618781632361878163236187654"
             "32107670521250767052125076705212507670521250767052",
             "21250767052125076705212507670521250767052125076543"
             "21098781632361878163236187816323618781632361878163",
             "10149656941014965694101496569410149656941014987654"
             "32109892743472989274347298927434729892743472989274",
             "09038545830903854583090385458309038545830903210987"
             "65432103854583090385458309038545830903854583090385",
             "98927434729892743472989274347298927434729898765432"
             "10987654965694101496569410149656941014965694101496",
             "87816323618781632361878163236187816323618765432109"
             "87654321076705212507670521250767052125076705212507",
             "76705212507670521250767052125076705212507654321098"
             "76543210987816323618781632361878163236187816323618",
             "65694101496569410149656941014965694101498765432109"
             "87654321098927434729892743472989274347298927434729",
             "54583090385458309038545830903854583090321098765432"
             "10987654321038545830903854583090385458309038545830",
             "43472989274347298927434729892743472989876543210987"
             "65432109876549656941014965694101496569410149656941",
             "32361878163236187816323618781632361876543210987654"
             "32109876543210767052125076705212507670521250767052",
             "21250767052125076705212507670521250765432109876543"
             "21098765432109878163236187816323618781632361878163",
             "10149656941014965694101496569410149876543210987654"
             "32109876543210989274347298927434729892743472989274",
             "09038545830903854583090385458309032109876543210987"
             "65432109876543210385458309038545830903854583090385",
             "98927434729892743472989274347298987654321098765432"
             "10987654321098765496569410149656941014965694101496",
             "87816323618781632361878163236187654321098765432109"
             "87654321098765432107670521250767052125076705212507",
             "76705212507670521250767052125076543210987654321098"
             "76543210987654321098781632361878163236187816323618",
             "65694101496569410149656941014987654321098765432109"
             "87654321098765432109892743472989274347298927434729",
             "54583090385458309038545830903210987654321098765432"
             "10987654321098765432103854583090385458309038545830",
             "43472989274347298927434729898765432109876543210987"
             "65432109876543210987654965694101496569410149656941",
             "32361878163236187816323618765432109876543210987654"
             "32109876543210987654321076705212507670521250767052",
             "21250767052125076705212507654321098765432109876543"
             "21098765432109876543210987816323618781632361878163",
             "10149656941014965694101498765432109876543210987654"
             "32109876543210987654321098927434729892743472989274",
             "09038545830903854583090321098765432109876543210987"
             "65432109876543210987654321038545830903854583090385",
             "98927434729892743472989876543210987654321098765432"
             "10987654321098765432109876549656941014965694101496",
             "87816323618781632361876543210987654321098765432109"
             "87654321098765432109876543210767052125076705212507",
             "76705212507670521250765432109876543210987654321098"
             "76543210987654321098765432109878163236187816323618",
             "65694101496569410149876543210987654321098765432109"
             "87654321098765432109876543210989274347298927434729",
             "54583090385458309032109876543210987654321098765432"
             "10987654321098765432109876543210385458309038545830",
             "43472989274347298987654321098765432109876543210987"
             "65432109876543210987654321098765496569410149656941",
             "32361878163236187654321098765432109876543210987654"
             "32109876543210987654321098765432107670521250767052",
             "21250767052125076543210987654321098765432109876543"
             "21098765432109876543210987654321098781632361878163",
             "10149656941014987654321098765432109876543210987654"
             "32109876543210987654321098765432109892743472989274",
             "09038545830903210987654321098765432109876543210987"
             "65432109876543210987654321098765432103854583090385",
             "98927434729898765432109876543210987654321098765432"
             "10987654321098765432109876543210987654965694101496",
             "87816323618765432109876543210987654321098765432109"
             "87654321098765432109876543210987654321076705212507",
             "76705212507654321098765432109876543210987654321098"
             "76543210987654321098765432109876543210987816323618",
             "65694101498765432109876543210987654321098765432109"
             "87654321098765432109876543210987654321098927434729",
             "54583090321098765432109876543210987654321098765432"
             "10987654321098765432109876543210987654321038545830",
             "43472989876543210987654321098765432109876543210987"
             "65432109876543210987654321098765432109876549656941",
             "32361876543210987654321098765432109876543210987654"
             "32109876543210987654321098765432109876543210767052",
             "21250765432109876543210987654321098765432109876543"
             "21098765432109876543210987654321098765432109878163",
             "10149876543210987654321098765432109876543210987654"
             "32109876543210987654321098765432109876543210989274",
             "09032109876543210987654321098765432109876543210987"
             "65432109876543210987654321098765432109876543210385",
             "98987654321098765432109876543210987654321098765432"
             "10987654321098765432109876543210987654321098765496",
             "87654321098765432109876543210987654321098765432109"
             "87654321098765432109876543210987654321098765432107",
             "76543210987654321098765432109876543210987654321098"
             "76543210987654321098765432109876543210987654321098",
         ], 100, 200)
    ]
)
def test_spiraldigits(field, M, N):
    result = run(
        __file__, 'solution.py',
        input="{},{}".format(M, N)
    )
    assert result.returncode == 0, result.stderr
    assert result.stdout.strip() == '\n'.join(
        ' '.join(
            c for c in row
        ) for row in field
    )
